import { PlatformAccessory } from "homebridge";
import { ProtectCameraConfig, ProtectEventPacket } from "unifi-protect";
import { ProtectCamera } from "./protect-camera.js";
import { ProtectCameraPackage } from "./protect-camera-package.js";
import { ProtectNvr } from "../protect-nvr.js";
export declare class ProtectDoorbell extends ProtectCamera {
    private chimeDigitalDuration;
    private defaultMessageDuration;
    private isMessagesEnabled;
    private isMessagesFromControllerEnabled;
    private messageSwitches;
    packageCamera: ProtectCameraPackage | null;
    constructor(nvr: ProtectNvr, device: ProtectCameraConfig, accessory: PlatformAccessory);
    protected configureDevice(): Promise<boolean>;
    private configureDoorbellLcdSwitch;
    private configurePackageCamera;
    private configurePhysicalChimes;
    protected configureMqtt(): boolean;
    updateDevice(): boolean;
    private getPhysicalChimeDuration;
    private getMessages;
    private validateMessageSwitches;
    private updateLcdSwitch;
    private setMessage;
    protected eventHandler(packet: ProtectEventPacket): void;
    private nvrEventHandler;
}
