import { ProtectPlatform } from "../protect-platform.js";
export declare class FfmpegCodecs {
    private _gpuMem;
    private _ffmpegVersion;
    private readonly log;
    private readonly platform;
    private readonly ffmpegExec;
    private readonly ffmpegCodecs;
    private readonly ffmpegHwAccels;
    constructor(platform: ProtectPlatform);
    probe(): Promise<boolean>;
    hasDecoder(codec: string, decoder: string): boolean;
    hasEncoder(codec: string, encoder: string): boolean;
    hasHwAccel(accel: string): boolean;
    get gpuMem(): number;
    get ffmpegVersion(): string;
    private probeFfmpegVersion;
    private probeFfmpegHwAccel;
    private probeFfmpegCodecs;
    private probeRpiGpuMem;
    private probeCmd;
}
