import { H264Level, H264Profile } from "homebridge";
import { ProtectCamera } from "../devices/index.js";
interface EncoderOptions {
    bitrate: number;
    fps: number;
    height: number;
    idrInterval: number;
    inputFps: number;
    level: H264Level;
    profile: H264Profile;
    useSmartQuality?: boolean;
    width: number;
}
export declare class FfmpegOptions {
    private readonly hwPixelFormat;
    private readonly log;
    private readonly platform;
    private readonly protectCamera;
    constructor(protectCamera: ProtectCamera);
    private configureHwAccel;
    get audioEncoder(): string[];
    get audioDecoder(): string;
    get videoDecoder(): string[];
    get cropFilter(): string;
    private defaultVideoEncoderOptions;
    recordEncoder(options: EncoderOptions): string[];
    streamEncoder(options: EncoderOptions): string[];
    get recordingDefaultChannel(): string | undefined;
    get hostSystemMaxPixels(): number;
    private getH264Level;
    private getH264Profile;
}
export {};
