/// <reference types="node" />
import { ProtectEventMetadata } from "unifi-protect";
import { ProtectCamera, ProtectDevice } from "./devices/index.js";
import { EventEmitter } from "node:events";
import { ProtectNvr } from "./protect-nvr.js";
export declare class ProtectEvents extends EventEmitter {
    private api;
    private hap;
    private log;
    private mqttPublishTelemetry;
    private nvr;
    private readonly eventTimers;
    private ufpApi;
    private ufpDeviceState;
    private platform;
    private unsupportedDevices;
    constructor(nvr: ProtectNvr);
    private updateUfp;
    private ufpUpdates;
    private manageDevices;
    private configureEvents;
    motionEventHandler(protectDevice: ProtectDevice, detectedObjects?: string[], metadata?: ProtectEventMetadata): void;
    private motionEventDelivery;
    doorbellEventHandler(protectDevice: ProtectCamera, lastRing: number | null): void;
}
