import { FeatureOptionEntry } from "homebridge-plugin-utils";
export interface ProtectOptions {
    controllers: ProtectNvrOptions[];
    debugAll: boolean;
    ffmpegOptions: string[];
    options: string[];
    ringDelay: number;
    verboseFfmpeg: boolean;
    videoEncoder: string;
    videoProcessor: string;
}
export interface ProtectNvrOptions {
    address: string;
    doorbellMessages: {
        duration: number;
        message: string;
    }[];
    mqttTopic: string;
    mqttUrl: string;
    name: string;
    overrideAddress: string;
    username: string;
    password: string;
}
interface ProtectFeatureOption extends FeatureOptionEntry {
    hasFeature?: string[];
    hasProperty?: string[];
    hasSmartObjectType?: string[];
    modelKey?: string[];
}
export declare const featureOptionCategories: {
    description: string;
    modelKey: string[];
    name: string;
}[];
export declare const featureOptions: {
    [index: string]: ProtectFeatureOption[];
};
export {};
