import { API, DynamicPlatformPlugin, Logging, PlatformAccessory, PlatformConfig } from "homebridge";
import { FeatureOptions, RtpPortAllocator } from "homebridge-plugin-utils";
import { ProtectOptions } from "./protect-options.js";
import { FfmpegCodecs } from "./ffmpeg/index.js";
export declare class ProtectPlatform implements DynamicPlatformPlugin {
    accessories: PlatformAccessory[];
    readonly api: API;
    readonly codecSupport: FfmpegCodecs;
    readonly config: ProtectOptions;
    private readonly controllers;
    readonly featureOptions: FeatureOptions;
    readonly log: Logging;
    readonly rtpPorts: RtpPortAllocator;
    private _hostSystem;
    verboseFfmpeg: boolean;
    constructor(log: Logging, config: PlatformConfig, api: API);
    configureAccessory(accessory: PlatformAccessory): void;
    private launchControllers;
    private probeHwOs;
    get hostSystem(): string;
    debug(message: string, ...parameters: unknown[]): void;
}
